# Import functions
. "$PSScriptRoot\functions\console.ps1"
. "$PSScriptRoot\functions\header.ps1"

# Initialize
Write-Header

Get-Info

Write-Separator


# get all json files
$jsonFiles = Get-ChildItem -Recurse -Filter "*.json" -Exclude "*.schema.*" | select -ExpandProperty FullName
$jsonSchemaFiles = Get-ChildItem -Recurse -Filter "*.schema.json" | select -ExpandProperty FullName

# find schema that matches location and name of file

$jsonFiles | Foreach-Object {
    $json = $_
    $jsonWithoutSchema = $json -replace "schema." -replace ""
    $schema = $jsonSchemaFiles | Where-Object {$($_ -replace "schema." -replace "") -eq $jsonWithoutSchema}
    
    if($schema) {
        $jsonContent = Get-Content $json 
        $result = $False

        # validate schema
        $result = Test-Json -Json $jsonContent -SchemaFile $schema -ErrorAction SilentlyContinue -ErrorVariable err
       
        if(!$result) {
            Write-Host "$json [Invalid], errors: $err"

        } else {
            Write-Host "$json [Valid]"
        }
    }
}


Write-Separator

Write-OutputCenter("And as always, have a nice day!")

Write-Separator
